//+------------------------------------------------------------------+ 
//|                                                    TimeZones.mq5 |
//|                              Copyright  2005. Alejandro Galindo | 
//|                                              http://elCactus.com | 
//+------------------------------------------------------------------+ 
//---  
#property copyright "Copyright  2005. Alejandro Galindo"
//---    
#property link "http://elCactus.com" 
//---   
#property version   "1.00"
#property description ""
//---        
#property indicator_buffers 0
//---   
#property indicator_plots   0
//+----------------------------------------------+ 
//|                  |
//+----------------------------------------------+ 
//---     
#property indicator_chart_window 
//+----------------------------------------------+
//|                            |
//+----------------------------------------------+
#define RESET 0                     //    ,   OnCalculate()    
#define DAILY_PERIOD_SECOND 86400   //      
#define WEEKLY_PERIOD_SECOND 604800 //        
//+----------------------------------------------+ 
//|                        |
//+----------------------------------------------+ 
enum ENUM_WIDTH // 
  {
   w_1 = 1,   //1
   w_2,       //2
   w_3,       //3
   w_4,       //4
   w_5        //5
  };
//+----------------------------------------------+
//|                        |
//+----------------------------------------------+
enum STYLE
  {
   SOLID_,       // 
   DASH_,        // 
   DOT_,         // 
   DASHDOT_,     //- 
   DASHDOTDOT_   //-    
  };
//+----------------------------------------------+
//|                        |
//+----------------------------------------------+
enum Hour    // 
  {
   H00=0,    //00
   H01,      //01
   H02,      //02
   H03,      //03
   H04,      //04
   H05,      //05
   H06,      //06
   H07,      //07
   H08,      //08
   H09,      //09
   H10,      //10
   H11,      //11
   H12,      //12
   H13,      //13
   H14,      //14
   H15,      //15
   H16,      //16
   H17,      //17
   H18,      //18
   H19,      //19
   H20,      //20
   H21,      //21
   H22,      //22
   H23,      //23
  };
//+----------------------------------------------+ 
//|                    |
//+----------------------------------------------+ 
//---  
input string LinesSirname="TimeZones";   //  
input uint WeeklyTotal=4;                //      
input uint FutureTotal=1;                //      
//---    
input color Line_Color_D=clrRed;         //   
input STYLE Line_Style_D=SOLID_;         //    
input ENUM_WIDTH Line_Width_D=w_3;       //   
input bool SetBackground_D=true;         //    
//---   -  GMT
input Hour GMT=H02; //
input color Line_Color_D1=clrDodgerBlue; //   GMT
input STYLE Line_Style_D1=SOLID_;        //   GMT
input ENUM_WIDTH Line_Width_D1=w_2;      //    GMT
input bool SetBackground_D1=true;        //     GMT
//---   -  MST
input Hour MST=H06; //
input color Line_Color_D2=clrLime;       //   MST
input STYLE Line_Style_D2=SOLID_;        //   MST
input ENUM_WIDTH Line_Width_D2=w_2;      //   MST
input bool SetBackground_D2=true;        //    MST
//---   -  EST
input Hour EST=H07; //
input color Line_Color_D3=clrDarkOrchid; //   EST
input STYLE Line_Style_D3=SOLID_;        //   EST
input ENUM_WIDTH Line_Width_D3=w_2;      //   EST
input bool SetBackground_D3=true;        //    EST
//+----------------------------------------------+
//---   ,   
//---      
uint Count_W[],Count_D0[],Count_D1[],Count_D2[],Count_D3[];
datetime VLineTime_W[],VLineTime_D0[],VLineTime_D1[],VLineTime_D2[],VLineTime_D3[];
//---      
uint WeeklyTotal_,LinesTotal_D_,LinesTotal_D,FutureTotal_D;
//---    
string Sirname_W,Sirname_D[4];
//+------------------------------------------------------------------+
//|                              |
//+------------------------------------------------------------------+   
bool CheckVLinePoint_D(datetime bartime1,datetime bartime0)
  {
//---
   MqlDateTime tm0,tm1;
   TimeToStruct(bartime0,tm0);
   TimeToStruct(bartime1,tm1);
   if(tm0.day_of_year!=tm1.day_of_year) return(true);
//---
   return(false);
  }
//+------------------------------------------------------------------+
//|                        |
//+------------------------------------------------------------------+   
bool CheckVLinePoint_DN(datetime bartime1,datetime bartime0,uint hour)
  {
//---
   MqlDateTime tm0,tm1;
   TimeToStruct(bartime0,tm0);
   TimeToStruct(bartime1,tm1);
   if(tm1.hour!=hour && tm0.hour==hour) return(true);
   if(tm0.day_of_year!=tm1.day_of_year && tm0.hour==hour) return(true);
//---
   return(false);
  }
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+   
bool CheckVLinePoint_W(int bar,datetime bartime)
  {
//---
   MqlDateTime tm;
   TimeToStruct(bartime,tm);
   if(tm.day_of_week==0 || tm.day_of_week==6) return(true);
//---
   return(false);
  }
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+  
class CRecount_ArrayZeroPos
  {
public:
   void              Recount_ArrayZeroPos(int &CoArr[],//        
                                          int Size)    //     
     {
      //---
      int numb,Max1,Max2;

      Max2=Size;
      Max1=Max2-1;

      m_count--;
      if(m_count<0) m_count=Max1;

      for(int iii=0; iii<Max2; iii++)
        {
         numb=iii+m_count;
         if(numb>Max1) numb-=Max2;
         CoArr[iii]=numb;
        }
      //---
     }
                     CRecount_ArrayZeroPos(){m_count=1;};
protected:
   int               m_count;
  };
//+------------------------------------------------------------------+
//|                                   |
//+------------------------------------------------------------------+
bool RenameVline(long     chart_id,    //  
                 string   oldname,     //   
                 string   newname)     //   
  {
//---
   if(ObjectFind(chart_id,oldname)>0)
     {
      ObjectSetString(chart_id,oldname,OBJPROP_NAME,newname);
      return(true);
     }
//---
   return(false);
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
void CreateVline(long     chart_id,      //  
                 string   name,          //  
                 int      nwin,          //  
                 datetime time1,         //   
                 color    Color,         //  
                 int      style,         //  
                 int      width,         //  
                 bool     background,    //   
                 string   text)          // 
  {
//---
   ObjectCreate(chart_id,name,OBJ_VLINE,nwin,time1,999999999);
   ObjectSetInteger(chart_id,name,OBJPROP_COLOR,Color);
   ObjectSetInteger(chart_id,name,OBJPROP_STYLE,style);
   ObjectSetInteger(chart_id,name,OBJPROP_WIDTH,width);
   ObjectSetString(chart_id,name,OBJPROP_TEXT,text);
   ObjectSetInteger(chart_id,name,OBJPROP_BACK,background);
   ObjectSetInteger(chart_id,name,OBJPROP_RAY,true);
   ObjectSetString(chart_id,name,OBJPROP_TOOLTIP,"\n"); //  
   ObjectSetInteger(chart_id,name,OBJPROP_BACK,true);   //   
//---
  }
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
void SetVline(long     chart_id,      //  
              string   name,          //  
              int      nwin,          //  
              datetime time1,         //   
              color    Color,         //  
              int      style,         //  
              int      width,         //  
              bool     background,    //   
              string   text)          // 
  {
//---
   if(ObjectFind(chart_id,name)==-1) CreateVline(chart_id,name,nwin,time1,Color,style,width,background,text);
   else
     {
      ObjectSetString(chart_id,name,OBJPROP_TEXT,text);
      ObjectMove(chart_id,name,0,time1,999999999);
     }
//---
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+     
void Deinit()
  {
//---
   int total=ObjectsTotal(0,0,-1)-1;
   string name,sirname;

   for(int numb=total; numb>=0 && !IsStopped(); numb--)
     {
      name=ObjectName(0,numb,0,-1);
      sirname=StringSubstr(name,0,StringLen(LinesSirname));

      if(sirname==LinesSirname) ObjectDelete(0,name);
     }
//---
   ChartRedraw(0);
  }
//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+ 
void OnInit()
  {
//---       
   if(Period()>PERIOD_H1) return;
   Deinit();
//---     
   WeeklyTotal_=WeeklyTotal+1;
//---
   LinesTotal_D=WeeklyTotal_*4;
   FutureTotal_D=FutureTotal;
   LinesTotal_D_=LinesTotal_D+FutureTotal_D;
//---    
   Sirname_W=LinesSirname+"_W_";
   Sirname_D[0]=LinesSirname+"_D0_";
   Sirname_D[1]=LinesSirname+"_D1_";
   Sirname_D[2]=LinesSirname+"_D2_";
   Sirname_D[3]=LinesSirname+"_D3_";
//---       
   ArrayResize(Count_D0,LinesTotal_D_);
   ArrayResize(VLineTime_D0,LinesTotal_D_);
   ArrayResize(Count_D1,LinesTotal_D_);
   ArrayResize(VLineTime_D1,LinesTotal_D_);
   ArrayResize(Count_D2,LinesTotal_D_);
   ArrayResize(VLineTime_D2,LinesTotal_D_);
   ArrayResize(Count_D3,LinesTotal_D_);
   ArrayResize(VLineTime_D3,LinesTotal_D_);
//---        
   string shortname;
   StringConcatenate(shortname,"TimeZones(",LinesSirname,", ",WeeklyTotal,")");
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---   
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+     
void OnDeinit(const int reason)
  {
//---
   Deinit();
//---
  }
//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+ 
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---       
   if(Period()>PERIOD_H1) return(RESET);
//---       
   if(rates_total<2) return(RESET);
   if(prev_calculated==rates_total) return(rates_total);
//---    
   string Name;
   datetime Time,TimeCur;
   int limit,bar;
   static datetime LastTime_D[4];
   static CRecount_ArrayZeroPos D0,D1,D2,D3;
   ArrayInitialize(LastTime_D,0);
//---        
   ArraySetAsSeries(time,true);
//---    limit        
   if(prev_calculated>rates_total || prev_calculated<=0)//      
     {
      limit=rates_total-2; //      
      uint VLineCount_W=0;
      for(bar=0; bar<=limit && !IsStopped(); bar++)
         if(CheckVLinePoint_W(bar,(time[bar]+time[bar+1])/2))
           {
            VLineCount_W++;
            if(VLineCount_W>=WeeklyTotal) break;
           }
      if(bar<limit) limit=bar;
     }
   else limit=rates_total-prev_calculated; //      
//---      
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      //---  -  GMT  
      if(CheckVLinePoint_DN(time[bar+1],time[bar],GMT))
        {
         Name=Sirname_D[1]+TimeToString(time[bar]);
         Time=VLineTime_D1[Count_D1[FutureTotal_D]];
         RenameVline(0,Sirname_D[1]+TimeToString(Time),Name);
         SetVline(0,Name,0,time[bar],Line_Color_D1,Line_Style_D1,Line_Width_D1,SetBackground_D1,"  GMT");
         VLineTime_D1[Count_D1[FutureTotal_D]]=time[bar];
         if(bar>0) D1.Recount_ArrayZeroPos(Count_D1,LinesTotal_D_);
         LastTime_D[1]=time[bar];
        }
      //---  -  MST  
      if(CheckVLinePoint_DN(time[bar+1],time[bar],MST))
        {
         Name=Sirname_D[2]+TimeToString(time[bar]);
         Time=VLineTime_D2[Count_D2[FutureTotal_D]];
         RenameVline(0,Sirname_D[2]+TimeToString(Time),Name);
         SetVline(0,Name,0,time[bar],Line_Color_D2,Line_Style_D2,Line_Width_D2,SetBackground_D2,"  MST");
         VLineTime_D2[Count_D2[FutureTotal_D]]=time[bar];
         if(bar>0) D2.Recount_ArrayZeroPos(Count_D2,LinesTotal_D_);
         LastTime_D[2]=time[bar];
        }

      //---  -  EST  
      if(CheckVLinePoint_DN(time[bar+1],time[bar],EST))
        {
         Name=Sirname_D[3]+TimeToString(time[bar]);
         Time=VLineTime_D3[Count_D3[FutureTotal_D]];
         RenameVline(0,Sirname_D[3]+TimeToString(Time),Name);
         SetVline(0,Name,0,time[bar],Line_Color_D3,Line_Style_D3,Line_Width_D3,SetBackground_D3,"  EST");
         VLineTime_D3[Count_D3[FutureTotal_D]]=time[bar];
         if(bar>0) D3.Recount_ArrayZeroPos(Count_D3,LinesTotal_D_);
         LastTime_D[3]=time[bar];
        }
      //---     
      if(CheckVLinePoint_D(time[bar+1],time[bar]))
        {
         Name=Sirname_D[0]+TimeToString(time[bar]);
         Time=VLineTime_D0[Count_D0[FutureTotal_D]];
         RenameVline(0,Sirname_D[0]+TimeToString(Time),Name);
         SetVline(0,Name,0,time[bar],Line_Color_D,Line_Style_D,Line_Width_D,SetBackground_D," ");
         VLineTime_D0[Count_D0[FutureTotal_D]]=time[bar];
         if(bar>0) D0.Recount_ArrayZeroPos(Count_D0,LinesTotal_D_);
         LastTime_D[0]=time[bar];
        }
     }
   TimeCur=TimeCurrent();
//---      (   )
   for(int numb=int(FutureTotal_D)-1; numb>=0 && !IsStopped(); numb--)
     {
      //---  -  GMT  
      Time=LastTime_D[1]+DAILY_PERIOD_SECOND*(FutureTotal_D-numb);
      if(TimeCur>=Time) Time+=DAILY_PERIOD_SECOND;
      if(TimeCur>=Time) Time+=DAILY_PERIOD_SECOND;
      Name=Sirname_D[1]+TimeToString(Time);
      RenameVline(0,Sirname_D[1]+TimeToString(VLineTime_D1[Count_D1[numb]]),Name);
      SetVline(0,Name,0,Time,Line_Color_D1,Line_Style_D1,Line_Width_D1,SetBackground_D1,"  GMT");
      VLineTime_D1[Count_D1[numb]]=Time;

      //---  -  MST  
      Time=LastTime_D[2]+DAILY_PERIOD_SECOND*(FutureTotal_D-numb);
      if(TimeCur>=Time) Time+=DAILY_PERIOD_SECOND;
      if(TimeCur>=Time) Time+=DAILY_PERIOD_SECOND;
      Name=Sirname_D[2]+TimeToString(Time);
      RenameVline(0,Sirname_D[2]+TimeToString(VLineTime_D2[Count_D2[numb]]),Name);
      SetVline(0,Name,0,Time,Line_Color_D2,Line_Style_D2,Line_Width_D2,SetBackground_D2,"  MST");
      VLineTime_D2[Count_D2[numb]]=Time;

      //---  -  EST  
      Time=LastTime_D[3]+DAILY_PERIOD_SECOND*(FutureTotal_D-numb);
      if(TimeCur>=Time) Time+=DAILY_PERIOD_SECOND;
      if(TimeCur>=Time) Time+=DAILY_PERIOD_SECOND;
      Name=Sirname_D[3]+TimeToString(Time);
      RenameVline(0,Sirname_D[3]+TimeToString(VLineTime_D3[Count_D3[numb]]),Name);
      SetVline(0,Name,0,Time,Line_Color_D3,Line_Style_D3,Line_Width_D3,SetBackground_D3,"  EST");
      VLineTime_D3[Count_D2[numb]]=Time;

      //---    0   
      Time=LastTime_D[0]+DAILY_PERIOD_SECOND*(FutureTotal_D-numb);
      if(TimeCur>=Time) Time+=DAILY_PERIOD_SECOND;
      if(TimeCur>=Time) Time+=DAILY_PERIOD_SECOND;
      Name=Sirname_D[0]+TimeToString(Time);
      RenameVline(0,Sirname_D[0]+TimeToString(VLineTime_D0[Count_D0[numb]]),Name);
      SetVline(0,Name,0,Time,Line_Color_D,Line_Style_D,Line_Width_D,SetBackground_D," ");
      VLineTime_D0[Count_D0[numb]]=Time;
     }
//--- 
   ChartRedraw(0);
   return(rates_total);
  }
//+------------------------------------------------------------------+
